package geometry.part4;

import geometry.part2.LineSegment;

public class Event implements Comparable<Event> {
    public enum Type { // イベントの種類
        SEGMENT_START, // 線分の始点
        SEGMENT_END,   // 線分の終点
        INTERSECTION   // 線分同士の交差
    }

    public Type type;
    public double x;
    public double y;
    // 点に関連する線分1
    public LineSegment segment1;
    // 点に関連する線分2（type = INTERSECTIONのときのみ使用）
    public LineSegment segment2;

    public Event(Type type, double x, double y, LineSegment segment1,
            LineSegment segment2) {
        this.type = type;
        this.x = x;
        this.y = y;
        this.segment1 = segment1;
        this.segment2 = segment2;
    }

    // Comparable<Event>の実装
    public int compareTo(Event e) {
        int c = Double.compare(y, e.y); // イベント点のy座標を比較
        if (c == 0) { // y座標が等しい場合はx座標を比較
            c = Double.compare(x, e.x);
        }
        return c;
    }
}
